> For the complete documentation index, see [llms.txt](https://manual.docs.microstream.one/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://manual.docs.microstream.one/3.0/data-store/customizing/custom-class-loader.md).

# Custom Class Loader

{% hint style="warning" %}
**This is the manual for older MicroStream versions (Version < 5.0).**

**The new documentation (Version >= 5.0) is located at:**

[https://docs.microstream.one/](https://docs.microstream.one/manual)
{% endhint %}

In certain environments or setups it is necessary to provide specific `ClassLoader` instances. This can be done by customizing the connection foundation.

If a single `ClassLoader` is sufficient, just create a new provider by handing over the instance:

```java
EmbeddedStorageManager storage = EmbeddedStorage.Foundation(Paths.get("mydb"))
    .onConnectionFoundation(cf -> 
        cf.setClassLoaderProvider(ClassLoaderProvider.New(myClassLoader))    
    )
    .start();
```

Or return a `ClassLoader` depending on the requested type:

```java
EmbeddedStorageManager storage = EmbeddedStorage.Foundation(Paths.get("mydb"))
    .onConnectionFoundation(cf -> 
        cf.setClassLoaderProvider(typeName -> {
            if(typeName.startsWith("com.company.module1."))
            {
                return module1ClassLoader;
            }
            if(typeName.startsWith("com.company.module2."))
            {
                return module2ClassLoader;
            }
            return ClassLoader.getSystemClassLoader();
        })    
    )
    .start();
```

## Class Loader in Application Server

Most application servers load the session's classes with the context class loader. Just use the one of the current thread:

```java
EmbeddedStorageManager storage = EmbeddedStorage.Foundation(Paths.get("mydb"))
    .onConnectionFoundation(cf -> 
        cf.setClassLoaderProvider(ClassLoaderProvider.New(
            Thread.currentThread().getContextClassLoader()
        ))    
    )
    .start();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://manual.docs.microstream.one/3.0/data-store/customizing/custom-class-loader.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
